package com.hanbit.comm.login;

import com.hanbit.comm.ejb.session.*;

import com.hanbit.comm.servlet.*;

import javax.servlet.http.*;


public class AuthorizationFilter implements Command {
    private static final String LOGIN_PAGE = "/index.jsp";
    private static final String UNAUTHORIZED_ACCESS_PAGE = "/unauth.jsp";
    private Command command;

    public AuthorizationFilter(Command command) {
        this.command = command;
    }

    public String execute(HttpServletRequest req) throws CommandException {
        HttpSession session = req.getSession();
        User user = (User) session.getAttribute("system.user");

        // Login  ...
        if (user == null) {
            return LOGIN_PAGE;
        }

        String programId = getPgmId(req.getServletPath());

        //    ...
        if (!user.canUse(programId)) {
            return UNAUTHORIZED_ACCESS_PAGE;
        }

        String next = command.execute(req);

        return next;
    }

    private String getPgmId(String path) {
        if (path == null) {
            return null;
        }

        if (path.toLowerCase().startsWith("/servlet/")) {
            int idx = path.toLowerCase().indexOf("/servlet/");

            return path.substring(idx);
        }

        return path;
    }
}