package com.hanbit.comm.performance;

import javax.servlet.http.*;
import com.hanbit.comm.servlet.*;

public class PerformanceFilter
implements Command
{
    private Command command;
    private String next;
    
    public PerformanceFilter(Command command)
    {
        this.command = command;
    }

    public String execute(HttpServletRequest req)
    throws CommandException{
        StopWatch watch = new StopWatch();
        
        next = command.execute(req);
        
        long   ellapsed = watch.getEllapsed();
        String className = command.getClass().getName();
        
        PerformanceManager mgr  = PerformanceManager.getInstance();
        CommandPerformance perf = (CommandPerformance)mgr.getPerformance(className);
        if(perf == null){
            perf = new CommandPerformance();
            perf.setClassName(className);
            mgr.register(perf);
        }
        perf.setSurvey(ellapsed);

        return next;
    }
}
