package com.hanbit.comm.util;

import java.sql.*;
import javax.sql.DataSource;
import javax.naming.*;
import java.util.Hashtable;

public class HanbitConnection{
    public static Connection getConnection()
    throws ConnectException {
        java.sql.Connection conn = null;
        try{
            Hashtable ht = new Hashtable();
            ht.put(Context.INITIAL_CONTEXT_FACTORY,"weblogic.jndi.WLInitialContextFactory");
            ht.put(Context.PROVIDER_URL,"t3://localhost");
            Context ctx = new InitialContext(ht);
            DataSource ds = (DataSource) ctx.lookup ("hanbitDataSource");
            conn = ds.getConnection();
        }catch(Exception e){
            throw new ConnectException();
        }
        return conn;
    }        
    public static Connection getBatchConnection()
    throws ConnectException {
        java.sql.Connection conn = null;
        try{
            Context ctx = new InitialContext();
            DataSource ds = (DataSource) ctx.lookup ("hanbitBatchDataSource");
            conn = ds.getConnection();
        }catch(Exception e){
            throw new ConnectException();
        }
        return conn;
    }        
    public static void close(Connection conn,ResultSet rset,Statement stmt){
        close(rset);
        close(stmt);
        close(conn);
    }
    public static  void close(Connection conn){
        try{
            if(conn != null) conn.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    public static  void close(ResultSet rset){
        try{
            if(rset != null) rset.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    public static  void close(Statement stmt){
        try{
            if(stmt != null) stmt.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
}
