package com.hanbit.comm.valueobject;

import com.hanbit.comm.util.NumberUtil;

import java.util.HashMap;


public class Row extends HashMap {
    public boolean containsKey(Object key) {
        if (key == null) {
            return super.containsKey(key);
        }

        return super.containsKey(((String) key).toUpperCase());
    }

    public Object get(Object key) {
        if (key == null) {
            return super.get(key);
        }

        return super.get(((String) key).toUpperCase());
    }

    public Object put(Object key, Object value) {
        if (key == null) {
            return super.put(key, value);
        }

        return super.put(((String) key).toUpperCase(), value);
    }

    public double getNumber(String key) {
        if (get(key) == null) {
            return (double) 0;
        }

        return Double.parseDouble((String) get(key));
    }

    public String getNumber(String key, String format) {
        if (get(key) == null) {
            return "";
        }

        return NumberUtil.setFormat((String) get(key), format);
    }

    public String getString(String key) {
        if (get(key) == null) {
            return "";
        }

        return (String) get(key);
    }
}