package com.hanbit.comm.valueobject;

import com.hanbit.comm.util.DateUtil;

import java.lang.reflect.*;

import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;


public class ValueObjectFactoryByPage extends ValueObjectFactory {
    private int rowCount;
    private int currRow = 0;

    public ValueObjectFactoryByPage(Object source, Object valueobject) {
        super(source, valueobject);

        // row ϱ
        HttpServletRequest req = (HttpServletRequest) source;
        Enumeration en = req.getParameterNames();

        while (en.hasMoreElements()) {
            String para = (String) en.nextElement();
            String[] values = req.getParameterValues(para);

            if (values.length > rowCount) {
                rowCount = values.length;
            }
        }

        System.out.println("RowCount:" + rowCount);
    }

    public boolean hasMoreElements() {
        if (rowCount > currRow) {
            return true;
        }

        return false;
    }

    public Object nextElement() {
        HttpServletRequest req = (HttpServletRequest) source;
        Enumeration paraNames = req.getParameterNames();
        Vector paraNameVt = new Vector();
        Object vo = null;
        Method[] methods = null;

        // parameter name ϱ
        while (paraNames.hasMoreElements()) {
            paraNameVt.addElement((String) paraNames.nextElement());
        }

        try {
            vo = valueobject.getClass().newInstance();
            methods = valueobject.getClass().getMethods();

            for (int i = 0; i < methods.length; i++) {
                String name = methods[i].getName();

                if (name.startsWith("set")) {
                    String paraName = getParaName(paraNameVt, name);
                    System.out.println("paraName" + paraName);

                    if (paraName != null) {
                        String paraValue = ((String[]) req.getParameterValues(
                                                      paraName))[currRow];
                        Class[] type = methods[i].getParameterTypes();

                        if ((paraValue != null) && (!paraValue.equals(""))) {
                            if (type[0].getName().equals("java.sql.Timestamp")) {
                                Object[] args = {
                                    DateUtil.makeTimestamp(paraValue)
                                };
                                methods[i].invoke(vo, args);
                            } else if (type[0].getName()
                                              .equals("java.lang.String")) {
                                Object[] args = { paraValue };
                                methods[i].invoke(vo, args);
                            } else if (type[0].getName().equals("int") || 
                                           type[0].getName()
                                                  .equals("java.lang.Integer")) {
                                Object[] args = { new Integer(paraValue) };
                                methods[i].invoke(vo, args);
                            } else if (type[0].getName().equals("double") || 
                                           type[0].getName()
                                                  .equals("java.lang.Double")) {
                                Object[] args = { new Double(paraValue) };
                                methods[i].invoke(vo, args);
                            } else if (type[0].getName().equals("float") || 
                                           type[0].getName()
                                                  .equals("java.lang.Float")) {
                                Object[] args = { new Float(paraValue) };
                                methods[i].invoke(vo, args);
                            } else if (type[0].getName().equals("long") || 
                                           type[0].getName()
                                                  .equals("java.lang.Long")) {
                                Object[] args = { new Long(paraValue) };
                                methods[i].invoke(vo, args);
                            }
                        }
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        currRow++;

        return vo;
    }

    private String getParaName(Vector para, String method) {
        for (int i = 0; i < para.size(); i++) {
            String name = (String) para.get(i);

            if (name.equalsIgnoreCase(method.substring(3))) {
                return (String) para.get(i);
            }
        }

        return null;
    }
}