package com.hanbit.ga.ejb.session.emp;

import com.hanbit.comm.ejb.entity.SnapShotTooOldException;
import com.hanbit.comm.ejb.session.HanbitSessionBean;
import com.hanbit.comm.util.DateUtil;

import com.hanbit.ga.ejb.entity.emp.*;

import java.rmi.RemoteException;

import java.util.*;

import javax.ejb.*;

import javax.naming.*;

import javax.transaction.*;


public class EmpSBBean extends HanbitSessionBean {
    private Context getInitialContext() throws NamingException {
        return new InitialContext();
    }

    public EmpVO employ(EmpVO vo) throws DuplicateKeyException, NamingException, 
                                         CreateException, RemoteException {
        Context ctx = getInitialContext();

        EmpHome home = (EmpHome) ctx.lookup("emp");
        vo.setUpddate(DateUtil.getToday());
        home.create(vo); // Create new Emp

        return vo;
    }

    public void retire(EmpVO vo) throws FinderException, NamingException, 
                                        RemoveException, RemoteException {
        Context ctx = getInitialContext();
        EmpHome home = (EmpHome) ctx.lookup("emp");
        Emp emp = (Emp) home.findByPrimaryKey(new Integer(vo.getEmpno()));

        emp.remove(); // Delete Emp
    }

    public EmpVO update(EmpVO vo) throws FinderException, NamingException, 
                                         RemoteException, 
                                         SnapShotTooOldException {
        Context ctx = getInitialContext();
        EmpHome home = (EmpHome) ctx.lookup("emp");
        Emp emp = home.findByPrimaryKey(new Integer(vo.getEmpno()));

        return emp.setVO(vo);
    }

    public Vector getEmpByDeptno(int deptno) throws FinderException, 
                                                    NamingException, 
                                                    RemoteException {
        Context ctx = getInitialContext();
        EmpHome home = (EmpHome) ctx.lookup("emp");
        Enumeration en = home.findByDeptno(deptno);

        Vector vt = new Vector();

        while (en.hasMoreElements()) {
            Emp emp = (Emp) en.nextElement();
            vt.add(emp.getVO());
        }

        return vt;
    }
}