package com.hanbit.ga;

import com.hanbit.comm.*;
import com.hanbit.ejb.*;

import javax.ejb.*;
import javax.naming.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;
import java.rmi.RemoteException;

public class GA1110DML implements Command{
    private String next;

    public GA1110DML(String next){
        this.next = next;
    }
    
    public String execute(HttpServletRequest req)
    throws CommandException{
        HttpSession session = req.getSession();
        String msgKey       = req.getRequestedSessionId();
        String cmd  = req.getParameter("cmd");
        String idx  = req.getParameter("idx");
       
        try{
            //DataModel Object
            Vector empVt      = (Vector)session.getAttribute(GA1110Servlet.VT_NAME);
            EmpDM  empDM      = null;
            DMFactoryByPage factory = new DMFactoryByPage();
            EmpDM pageDM      = (EmpDM)factory.getDataModel(GA1110Servlet.DM_NAME,req);
            //Transaction Object
            Context ctx = new InitialContext();
            EmpSBHome home =(EmpSBHome)ctx.lookup("com.hanbit.ejb.EmpSBHome");
            EmpSB empSB = home.create();

            if(cmd.equals("insert")){
                if(empVt == null){
                    empVt = new Vector();
                    session.setAttribute(GA1110Servlet.VT_NAME,empVt);
                }
                pageDM.setUpdUser("7934");
                empSB.insert(pageDM);
                empVt.add(pageDM);
                req.setAttribute(GA1110Servlet.DM_NAME,pageDM);
                req.setAttribute(msgKey,new Message("Successfully Inserted"));
                return next+"?idx="+(empVt.size() - 1);
            } else if(cmd.equals("delete")){
                if(empVt != null){
                    empDM = (EmpDM)empVt.get(Integer.parseInt(idx));
                    empSB.delete(empDM);
                    empVt.removeElementAt(Integer.parseInt(idx));
                    req.setAttribute(msgKey,new Message("Successfully Deleted"));
                }
            } else if(cmd.equals("update")){
                if(empVt != null){
                    empDM = (EmpDM)empVt.get(Integer.parseInt(idx));
                    pageDM.setUpdUser("7934");
                    empDM.setAll(pageDM);
                    empSB.update(empDM);
                    req.setAttribute(GA1110Servlet.DM_NAME,empDM);
                    req.setAttribute(msgKey,new Message("Successfully Updated"));
                }
            }
        }catch(DuplicateKeyException e){
            req.setAttribute(msgKey,new Message("Already Exist!"));
            return GA1110Servlet.dir+"msg.jsp";
        }catch(FinderException e){
            req.setAttribute(msgKey,new Message("Already Deleted.Please Requery!"));
            return GA1110Servlet.dir+"msg.jsp";
        }catch(SnapShotTooOldException e){
            req.setAttribute(msgKey,new Message("Already Updated.Please Requery!"));
            return GA1110Servlet.dir+"msg.jsp";
        }catch(Exception e){
            throw new CommandException(e);
        }
        return next;
    }
}
