package com.hanbit.ga.ga1117;

import com.hanbit.comm.servlet.*;
import com.hanbit.comm.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;
import java.net.*;
import java.io.*;

import javax.mail.*;
import javax.activation.*;
import javax.mail.internet.*;

public class GA1117Mail implements Command{
    private String next;
    // Default SMTPServer
    private final String SMTPServer = "203.239.8.4";
    private HashMap partMap         = new HashMap();
    private String htmlMessage      = null;

    public GA1117Mail(String next){
        this.next = next;
    }
    // javax.mail.Session   ޽.
    private javax.mail.Session getSession(){
        Properties pro = System.getProperties();
        pro.put("mail.smtp.host",SMTPServer);
        javax.mail.Session session = javax.mail.Session.getInstance(pro,null);
        return session;
    }
    // Image File Cssϸ óѴ.
    private boolean isWantedFile(String file){
        if(file == null) return false;
        if(file.toLowerCase().endsWith("gif")) return true;
        if(file.toLowerCase().endsWith("jpg")) return true;
        if(file.toLowerCase().endsWith("jpeg")) return true;
        if(file.toLowerCase().endsWith("png"))  return true;
        if(file.toLowerCase().endsWith("css"))  return true;
        return false;
    }
    
    private void setAddress(MimeMessage theMessage,String argTo,javax.mail.Message.RecipientType type)
    throws AddressException,MessagingException
    {
        if((theMessage == null) || (argTo == null)) return;
        StringTokenizer tokenizer = new StringTokenizer(argTo,",",false);
        while(tokenizer.hasMoreElements()){
            String token = tokenizer.nextToken();
            InternetAddress[] address = {new InternetAddress(token)};
            theMessage.addRecipients(type,address);
        }
    }
    // Create Server URL
    private URL makeURL(String server){
        URL url = null;
        try{
            url = new URL("http://"+server);
        }catch(Exception e){
            try{
                url = new URL("http://www.hanbit.co.kr");
            }catch(Exception ee){}
        }
        return url;
    }
    private void makeInclude(String html,String server){
        if(html == null) return ;
        StringBuffer buff = new StringBuffer();
        StringTokenizer tokenizer = new StringTokenizer(html," ",true);
        URL url = makeURL(server);
        while(tokenizer.hasMoreElements()){
            String token = tokenizer.nextToken();
            if(token.toLowerCase().startsWith("src=") || token.toLowerCase().startsWith("href=")){
                String src = token.substring(token.indexOf('=')+1);
                if(src.startsWith("\""))
                    src = src.substring(1,src.lastIndexOf('"'));
                if(src.startsWith("'"))
                    src = src.substring(1,src.lastIndexOf('\''));
                if(isWantedFile(src)){
                    String cid = String.valueOf(src.hashCode());
                    token = token.substring(0,token.indexOf('=')+1)+ "cid:"+cid;
                    if(!partMap.containsKey(cid)){
                        try{
                            URL srcUrl = new URL(url,src);
                            MimeBodyPart part = new MimeBodyPart();
                            InputStream in = srcUrl.openStream();
                            part.setDataHandler(new DataHandler(srcUrl));
                            part.setHeader("Content-ID",cid);
                            partMap.put(cid,part);
                        }catch(Exception fe){
                        }
                    }
                }
            }
            buff.append(token);
        }
        htmlMessage = buff.toString();
    }
    
    public String execute(HttpServletRequest req)
    throws CommandException{
        HttpSession session = req.getSession();
        String msgKey       = req.getRequestedSessionId();
        Vector vt = null;
        String argFrom    = req.getParameter("argFrom"); // From
        String argTo      = req.getParameter("argTo");   // To
        String argCC      = req.getParameter("argCC");   // Carbon Copy
        String argSubject = req.getParameter("argSubject"); // Subject
        String argHTMLMessage = req.getParameter("argHTMLMessage"); // HTML Contents

        try{

            MimeMessage theMessage = new MimeMessage(getSession());

            MimeMultipart multipart = new MimeMultipart("alternative");

            InternetAddress fromAddress = new InternetAddress(argFrom);
            theMessage.setFrom(fromAddress);
            setAddress(theMessage,argTo,javax.mail.Message.RecipientType.TO); // .
            setAddress(theMessage,argCC,javax.mail.Message.RecipientType.CC); // .

            if((argSubject != null) && !argSubject.trim().equals("")) //  .
                theMessage.setSubject(argSubject,"EUC-KR");
            
            String server = req.getServerName();
            makeInclude(argHTMLMessage,server); // Խų ̹ BodyPart .

            MimeBodyPart part1 = new MimeBodyPart(); // Main Body Part(HTML)
            part1.setDataHandler(new DataHandler(new ByteArrayDataSource(htmlMessage,"text/html; charset=euc-kr")));
            part1.setHeader("X-Mailer","Hanbit Web-Form Mailer");
            part1.setHeader("Content-Transfer-Encoding","8bit");
            part1.setHeader("Content-Type","text/html");
            multipart.addBodyPart(part1);

            // Image BodyPart ԽŴ.
            if(partMap != null){
                Iterator it = partMap.values().iterator();
                while(it.hasNext()){
                    MimeBodyPart part = (MimeBodyPart)it.next();
                    multipart.addBodyPart(part);
                }
            }
            //  related̴.(RFC2387 )
            multipart.setSubType("related");
            theMessage.setContent(multipart);
            Transport.send(theMessage);
        }catch(Exception e){ //ܻ Ƽ ڿ ش.
            e.printStackTrace();
        }
        return next;
    }
}