<%@ page isErrorPage="true" %>
<%@ page import="java.util.*,java.io.*" %>
<%@ page contentType="text/html; charset=EUC-KR" %> 

<html>
<head><title>Error Page</title></head>

<body bgcolor=#ffffff>

<font face="Helvetica">

<h2><font color=#FF0000>JSP Error Page</font></h2>
<hr>

<% if (exception != null) { %>
<p> An exception was thrown: <b> <%= exception %>

<p> With the following stack trace:
<pre>

<%
    ByteArrayOutputStream ostr = new ByteArrayOutputStream();
    exception.printStackTrace(new PrintStream(ostr));
    out.print(ostr);
    out.print(makeErrorReport(request,exception));
%>
</pre>

<!-- This next block executes if this page is loaded without
     an exception. --> 
<% } else  { %>
<p> <font color=#FF0000><b>Error Page Error:</b></font>
    Error Page was called with a null exception. 
    This happens if you request this page directly. It
    should only be served in response to an exception on 
    another JSP page.   
<% } %>


<p>
<hr>

</body>
</html>
<%!
public String makeErrorReport(HttpServletRequest req,Throwable e){
	StringBuffer buffer = new StringBuffer();
	reportException(buffer,e);
	reportRequest(buffer,req);
	reportParameters(buffer,req);
	reportHeaders(buffer,req);
	reportCookies(buffer,req);
	return buffer.toString();
}
public void reportException(StringBuffer buffer,Throwable e){
	StringWriter writer = new StringWriter();
	e.printStackTrace(new PrintWriter(writer));
	buffer.append(writer.getBuffer());
	buffer.append('\n');
}
public void reportRequest(StringBuffer buffer,HttpServletRequest req){
	buffer.append("Request: ");
	buffer.append(req.getMethod());
	buffer.append(' ');
	buffer.append(HttpUtils.getRequestURL(req));
	String queryString = req.getQueryString();
	if(queryString != null){
		buffer.append('?');
		buffer.append(queryString);
	}
	buffer.append("\nSession ID: ");
	String sessionId = req.getRequestedSessionId();
	if(sessionId == null){
		buffer.append("none");
	}else if(req.isRequestedSessionIdValid()){
		buffer.append(sessionId);
		buffer.append(" (from ");
		if(req.isRequestedSessionIdFromCookie())
			buffer.append("cookie)\n");
		else if(req.isRequestedSessionIdFromURL())
			buffer.append("url)\n");
		else
			buffer.append("unknown)\n");
	} else {
		buffer.append("invalid\n");
	}
}
public void reportParameters(StringBuffer buffer,HttpServletRequest req){
	Enumeration names = req.getParameterNames();
	if(names.hasMoreElements()){
		buffer.append("Parameters:\n");
		while(names.hasMoreElements()){
			String name = (String)names.nextElement();
			String[] values = req.getParameterValues(name);
			for(int i=0;i < values.length;i++){
				buffer.append("    ");
				buffer.append(name);
				buffer.append(" : ");
				buffer.append(values[i]);
				buffer.append('\n');
			}
		}
	}
}
public void reportHeaders(StringBuffer buffer,HttpServletRequest req){
	Enumeration names = req.getHeaderNames();
	if(names.hasMoreElements()){
		buffer.append("Headers:\n");
		while(names.hasMoreElements()){
			String name = (String)names.nextElement();
			String value = req.getHeader(name);
			buffer.append("    ");
			buffer.append(name);
			buffer.append(": ");
			buffer.append(value);
			buffer.append('\n');
		}
	}
}
public void reportCookies(StringBuffer buffer,HttpServletRequest req){
	Cookie[] cookies = req.getCookies();
	int l = cookies.length;
	if(l > 0){
		buffer.append("Cookies:\n");
		for(int i=0;i<l;i++){
			Cookie cookie = cookies[i];
			buffer.append("    ");
			buffer.append(cookie.getName());
			buffer.append(" = ");
			buffer.append(cookie.getValue());
			buffer.append('\n');
		}
	}
}
%>
